#include <rtx51tny.h>
#include <reg51.h>
#include <stdio.h>
#include <stdlib.h>
#include <dsw.h>

#ifndef READ
	#define	READ 1
#endif
#ifndef WRITE
	#define	WRITE 0
#endif

#define	EEPROM_WAIT	1

extern void Delay(unsigned char);

extern void I2C_Start(void);
extern void I2C_Stop(void);
extern unsigned char I2C_Read(unsigned char);
extern unsigned char I2C_SendByte(unsigned char);
extern unsigned char I2C_SendAddr(unsigned char);

#define	Radix10	10
#define	Radix16	16

#define	AddrDS1307A	0xD0							//Adresa pre DS1307+ - tzv. CONTROL_BYTE

#define	Addr_Sec		0x00
#define	Addr_Min		0x01
#define	Addr_Hod		0x02
#define	Addr_Day		0x03
#define	Addr_Den		0x04
#define	Addr_Mes		0x05
#define	Addr_Rok		0x06
#define	Addr_SQW		0x07
#define	CTRL_RS0		0x01
#define	CTRL_RS1		0x02
#define	CTRL_SQWE		0x10
#define	CTRL_OUT		0x80

extern unsigned char BCD(unsigned char);
extern unsigned char DEC(unsigned char);

unsigned char Get_Time(unsigned char Adresa, unsigned char Addr)
{
 register unsigned char LSB;
 I2C_SendAddr(Adresa+WRITE);
 I2C_SendByte(Addr);
//-------------------------------------------------- 
 I2C_SendAddr(Adresa+READ);
 LSB=I2C_Read(0);		//1 - Vyzaduje sa zo SLAVE-a potvrdenie ACK=0!!!
 I2C_Stop();				//0 - Vyzaduje sa z MASTER-a potvrdenie ACK=1!!!
//**************************************************
 return(DEC(LSB));	//Vraciam vysledok v desiatkovej sustave
//**************************************************	}
}

void Set_Time(unsigned char Adresa, unsigned char Addr, unsigned char Data)
{
 I2C_SendAddr(Adresa+WRITE);
 I2C_SendByte(Addr);
//-------------------------------------------------- 
 I2C_SendByte(BCD(Data));	//Vraciam vysledok v BCD formate
 I2C_Stop();
}

void Ini_Time(unsigned char Adresa, unsigned char Addr, unsigned char Data)
{
 I2C_SendAddr(Adresa+WRITE);
 I2C_SendByte(Addr);
//-------------------------------------------------- 
 I2C_SendByte(Data);
 I2C_Stop();
}

void Init_Time(void)
{
 unsigned char time;
 time=Get_Time(AddrDS1307A,Addr_Sec);
 Ini_Time(AddrDS1307A,Addr_Sec,time&0x7F);									//Nezabudnut povolit CH=0 bit pre povolenie oscilatora, po resete je vsetko nedefinovane !!!
 time=Get_Time(AddrDS1307A,Addr_Hod);
 Ini_Time(AddrDS1307A,Addr_Hod,time&(~0x40));								//6 bit na 0, aby bol 24 hodinovy cas 
 time=Get_Time(AddrDS1307A,Addr_SQW);
 Set_Time(AddrDS1307A,Addr_SQW,time|CTRL_SQWE);							//1s interval  
}
