#include <rtx51tny.h>
#include <reg51.h>
#include <stdio.h>
#include <stdlib.h>
#include <dsw.h>

#define	K	(1.0/256.0)

#ifndef READ
	#define	READ 1
#endif
#ifndef WRITE
	#define	WRITE 0
#endif

#define	EEPROM_WAIT	10

extern void Delay(unsigned char);

extern void I2C_Start(void);
extern void I2C_Stop(void);
extern unsigned char I2C_Read(unsigned char);
extern unsigned char I2C_SendByte(unsigned char);
extern unsigned char I2C_SendAddr(unsigned char);

#ifdef DS1631												//DS1631 je maximlne 12bitov teplomer
 #define START_CONVERT   	0x51			//DS1631 I2C_START_CONVERT = 0x51, DS1624 I2C_START_CONVERT = 0xEE
#endif

#ifdef DS1624												//DS1624 je maximlne 13bitov teplomer
 #define START_CONVERT   	0xEE			//DS1631 I2C_START_CONVERT = 0x51, DS1624 I2C_START_CONVERT = 0xEE
 #define ACCESS_MEMORY   	0x17			//DS1624
#endif

#define STOP_CONVERT     	0x22
#define	ACCESS_TH					0xA1
#define	ACCESS_TL					0xA2
#define READ_TEMPERATURE 	0xAA
#define DS1631_COMMAND		0xAC
#define DS1624_COMMAND		0xAC
#define COMMAND_DONE			0x80
#define COMMAND_1SHOT			0x01
#define POR								0x54
#define READ_COUNTER			0xA8			//DS1621
#define READ_SLOPE				0xA9			//DS1621

#define AddrDS1631A	0x90							//Adresa pre DS1621,DS1624,DS1631 - tzv. CONTROL_BYTE
#define AddrDS1624A	0x90							//Adresa pre DS1621,DS1624,DS1631 - tzv. CONTROL_BYTE
#define AddrAT24c32	0xA0							//Adresa pre AT24C08 az AT24C64 - tzv. CONTROL_BYTE
#define	AddrDS1807A	0x50							//Adresa pre DS1807A - tzv. CONTROL_BYTE

unsigned char Get_Int_Temp(unsigned char Adresa)
{
 register unsigned char MSB,LSB;
 I2C_SendAddr(Adresa+WRITE);
 I2C_SendByte(START_CONVERT);
 I2C_Stop();
//---------------------------------------------------
 I2C_SendAddr(Adresa+WRITE);
 I2C_SendByte(STOP_CONVERT);
 I2C_Stop();
//---------------------------------------------------
 I2C_SendAddr(Adresa+WRITE);
 I2C_SendByte(READ_TEMPERATURE);
 I2C_SendAddr(Adresa+READ);
 MSB=I2C_Read(1);			//Vyzaduje sa zo SLAVE-a potvrdenie ACK=0!!!
 LSB=I2C_Read(0);			//Vyzaduje sa z MASTER-a potvrdenie ACK=1!!!
 I2C_Stop();
//**************************************************
// if(MSB>=0x80) return((MSB*256+LSB)-65536); else return(MSB*256+LSB);														//Je to OK !!!
 return(MSB);																																											//Je to OK !!!
//**************************************************	
}

#ifdef DS1624

void Write_Eprom_DS1624(unsigned char Adresa, unsigned char EEprom_Addr, unsigned char Data)	//Funguje zapis a aj citanie do DS1624
{
 I2C_SendAddr(Adresa+WRITE);
 I2C_SendByte(ACCESS_MEMORY);
 I2C_SendByte(EEprom_Addr);
 I2C_SendByte(Data);
 I2C_Stop();
 os_wait(K_TMO,EEPROM_WAIT,NULL);		//Cakam 10ms cez RTX51 Full
}

unsigned char Read_Eprom_DS1624(unsigned char Adresa, unsigned char EEprom_Addr)	//Funguje zapis a aj citanie do DS1624
{
 register unsigned char LSB;
 I2C_SendAddr(Adresa+WRITE);
 I2C_SendByte(ACCESS_MEMORY);
 I2C_SendByte(EEprom_Addr);
 I2C_SendAddr(Adresa+READ); 
 LSB=I2C_Read(0);
 I2C_Stop();
 return(LSB);
}

#endif