#include <stdio.h>				/* standard I/O .h-file               */
#include <ctype.h>				/* character functions                */
#include <string.h>				/* string and memory functions        */
#include <stdlib.h>
#include <at89LP4052.h>
#include <rtx51tny.h>
#include <dsw.h>

#include <adresy.inc>

#define Port		P1
#define	LCD			0xFF		//Inicializacia portu ....
#ifdef x12
 #define	Dlzka		255		//pre 18.432MHz AT89LP4052
#else
 #define	Dlzka		60		//pre 18.432MHz
#endif

sbit	LCD_RW	=	P1^0;
sbit	LCD_RS	=	P1^1;
sbit	LCD_EN	=	P3^7;

extern void Delay(unsigned char);

const unsigned char Riadok1=0x00,Riadok2=0x40;

unsigned char Buffer[LCD_Size+1];

sbit LCD7	=	P1^7;
sbit LCD6	=	P1^6;
sbit LCD5	=	P1^5;
sbit LCD4	=	P1^4;

void LCD_Clock(void)
{
 LCD_EN=1;
 #ifdef x12					//Cakaj cca. 50us
  Delay(Dlzka);			
  Delay(Dlzka);
  Delay(Dlzka);
 #else							//Cakaj cca. 50us
  Delay(Dlzka);
 #endif
 LCD_EN=0;
}

void LCD_Send(unsigned char Data)
{
 LCD7=(Data&0x80)?1:0;		//Posielam MSB
 LCD6=(Data&0x40)?1:0;
 LCD5=(Data&0x20)?1:0;
 LCD4=(Data&0x10)?1:0;
 LCD_Clock();
 LCD7=(Data&0x08)?1:0;		//Posielam LSB
 LCD6=(Data&0x04)?1:0;
 LCD5=(Data&0x02)?1:0;
 LCD4=(Data&0x01)?1:0;
 LCD_Clock();
}

void LCD_Data(unsigned char Data)
{
 LCD_RS=1;  						//Pretoze odosielam data !!!
 LCD_EN=0;
 LCD_RW=0;
 LCD_Send(Data);
}

void LCD_Cmd(unsigned char Data)
{
 LCD_RS=0;							//Pretoze odosielam prikaz !!!
 LCD_EN=0;
 LCD_RW=0;
 LCD_Send(Data); 
}

void LCD_ClrScr(void)
{
 LCD_Cmd(0x01);
 os_wait(K_TMO,2,NULL);
}

void LCD_Goto(unsigned char Ptr)
{
 LCD_Cmd(0x80+Ptr);
 Delay(Dlzka);
}

void LCD_Home(void)
{
 LCD_Cmd(0x02);
 os_wait(K_TMO,2,NULL);
}

void LCD_Init(void)
{
 LCD_RS=0;
 LCD_RW=0;
 LCD_EN=0;
 #ifdef x12
  P1M0=P3M0=P1M1=P3M1=0x00;
 #endif
 Port=LCD;
 os_wait(K_TMO,20,NULL);	//Cakaj cca. 20ms
 LCD_Cmd(0x33);
 os_wait(K_TMO,5,NULL);
 LCD_Cmd(0x32);
 os_wait(K_TMO,5,NULL); 
 LCD_Cmd(0x20+0x08);
 LCD_Cmd(0x10+0x00);
 LCD_Cmd(0x08+0x04);
 LCD_Cmd(0x04+0x02);
 LCD_ClrScr();
 LCD_Goto(Riadok1); 
 LCD_Home();
}

void LCD_Write_String(char *String)
{
 register unsigned char i;
 for(i=0x00; i<=sizeof(Buffer); i++)
  {
	 switch(*String)
		{
		 case	'\n'	:
		 case	'\r'	:
		 case	'\0'	:	*String=' '; break;
		}
		LCD_Data(*String++);
	}
 memset(Buffer,' ',sizeof(Buffer));	
}