#include <stdio.h>				/* standard I/O .h-file               */
#include <ctype.h>				/* character functions                */
#include <string.h>				/* string and memory functions        */
#include <stdlib.h>
#include <at89LP4052.h>
#include <rtx51tny.h>
#include <dsw.h>

#include <adresy.inc>

#define	SYSTEM		0
#define	CLOCK			1
#define	SERIAL		2

extern unsigned char Buffer[LCD_Size+1];

#ifdef INT232

void IntRS232(void) interrupt 4 //using 3
{
 switch(SCON&0x03)
  {
	 case	0x01	:	RI=0; isr_send_signal(SERIAL); break;
	 case	0x02	:	TI=0; break;
	 case	0x03	:	TI=RI=0; break;
	}
}

unsigned char Addr;

void Serial(void) _task_ SERIAL		//Otestovane a ide OK
{
 bit RECEIVE;
 register unsigned char i;
 ES=1;
 while(1)
  {
	 os_wait(K_SIG,0xFF,NULL);
	 if(Token==SBUF)
	  {
		 os_wait(K_SIG,0xFF,NULL);
		 switch(Addr=SBUF)
		  {
			 case	Adresa1	:	
			 case	Adresa2	:
			 case	Adresa3	:
			 case	Adresa4	:	RECEIVE=0; i=0x00;							//Prijal som platnu adresu ...
											while(!RECEIVE)
											 {
											  os_wait(K_SIG,0xFF,NULL);
											  switch(Buffer[i++]=SBUF) 			//Citam SERIAL az pokial nenajdem koniec riadku, ako gets() ........
												 {
												  case	'\r'	:
													case	'\n'	:
													case	'\0'	:	RECEIVE=1; os_send_signal(SYSTEM);  break; 
												 }
											 }
											break;
			 default			:	break;								
			}
		}
	}	
}

#else

unsigned char Readkey(void)		//Otestovane a ide OK
{
 while(!RI) os_switch_task(); 
 RI=0;
 return(SBUF);
}

unsigned char Addr;

void Serial(void) _task_ SERIAL
{
 bit RECEIVE;
 register unsigned char i;
 ES=0;
 while(1)
  {
	 if(Token==Readkey())
	  {
		 switch(Addr=Readkey())
		  {
			 case	Adresa1	:	
			 case	Adresa2	:
			 case	Adresa3	:
			 case	Adresa4	:	RECEIVE=0; i=0x00;							//Prijal som platnu adresu ...
											while(!RECEIVE)
											 {
											  switch(Buffer[i++]=Readkey()) //Citam SERIAL az pokial nenajdem koniec riadku, ako gets() ........
												 {
												  case	'\r'	:
													case	'\n'	:
													case	'\0'	:	RECEIVE=1; os_send_signal(SYSTEM);  break; 
												 }
											 }
											break;
			 default			:	break;								
			}
		}
	}	
}

#endif

void Init_Serial(void)
{
 #define XTAL 18.432E6
 #define BAUD 19200
 #ifdef x12
 TH1=TL1=(0x100-(((long int)XTAL/192)/BAUD)*12);
 #else
 TH1=TL1=(0x100-(((long int)XTAL/192)/BAUD));
 #endif
 PCON|=0x80;				//Dvojita prenosova rychlost
 SCON|=0x50;				//8 bit prenos
 TMOD|=0x20;				//8 bitovy autoreload
 TR1=1;							//Running timer
 TI=1;							//Musi byt, pretoze sa to vyzaduje od Keila pre printf() !!!
}